<script lang="ts">
  export let players: Player[];

  function cardPoints(player: Player) {
    return player.cards
      .filter((card) => !player.cards.includes(card - 1))
      .reduce((a, b) => a + b, 0);
  }

  function score(player: Player): number {
    return -cardPoints(player) + player.chips;
  }

  let sortedPlayers: Player[];
  $: {
    sortedPlayers = [...players];
    sortedPlayers.sort((a, b) => score(b) - score(a));
  }

  function rank(player: Player) {
    let playerScore = score(player);
    let betterPlayers = players.filter((p) => score(p) > playerScore).length;
    return betterPlayers + 1;
  }

  $: bestScore = Math.max(...players.map((p) => score(p)));
  $: winners = players.filter((p) => score(p) === bestScore);
</script>

<div class="wrapper">
  <h2>
    {#if winners.length === 1}
      <gs6-user userid={winners[0].id} /> wins!
    {:else}
      {#each winners.slice(0, -2) as winner}
        <span><gs6-user userid={winner.id} />, </span>
      {/each}
      <gs6-user userid={winners[winners.length - 2].id} /> and
      <gs6-user userid={winners[winners.length - 1].id} /> win!
    {/if}
  </h2>

  <table>
    <thead>
      <tr>
        <th />
        <th />
        <th>Cards</th>
        <th>Chips</th>
        <th>Total</th>
      </tr>
    </thead>
    <tbody>
      {#each sortedPlayers as player}
        <tr>
          <td class="rank">
            {rank(player)}
          </td>
          <td class="player">
            <gs6-user userid={player.id} />
          </td>
          <td>− {cardPoints(player)}</td>
          <td>+ {player.chips}</td>
          <td class="total">
            {#if score(player) < 0}−{/if}
            {Math.abs(score(player))}
          </td>
        </tr>
      {/each}
    </tbody>
  </table>
</div>

<style>
  .wrapper {
    padding: 2rem;
  }

  h2 {
    text-align: center;
    margin-bottom: 3rem;
  }

  th,
  td {
    padding: 1rem;
    white-space: nowrap;
  }
  table {
    width: 100%;
    text-align: center;
    border-collapse: collapse;
    border-style: hidden;
  }

  td.player {
    text-align: left;
  }
  table th {
    border-bottom: 0.1rem solid rgb(206, 206, 206);
  }

  .rank {
    font-weight: 500;
    text-align: center;
  }
  .total {
    font-weight: bold;
  }
</style>
